;;;###autoload
(defun context-help () ; Use help-level for double/triple-clicks ?
"Context sensitive Short-Cut to the normal help functions/commands."
  (interactive) (let ((pos (point)))
  (cond ((and (eq last-context-help-position pos)
              (eq last-command this-command)) ; toggling this behaviour !
                         (setq this-command 'dummy) (describe-mode))
        ;;
        (context-help-function (funcall context-help-function))
        (t (describe-mode)))
  (setq last-context-help-position pos)))
(setq last-context-help-position nil); used for mouse-resetting of point
;;;
(defvar context-help-function nil
"Function or list of functions called by `context-help'.
Each buffer has its own value of this variable.")
;;
(make-variable-buffer-local 'context-help-function)
;;
(set-default 'context-help-function nil) ;; ?'describe-mode)
;;;
(defvar context-help-default-functions
  '((client-mode     . client-help-field)
    (permas-dat-mode . help-dat-command)
    (doc-mode        . show-page)
    (permas-nas-mode . help-nas-keyword)
    (occur-mode      . occur-mode-goto-occurrence)
    (shell-mode      . '(manual-entry t))
    (timecard-mode   . timecard-context-help)
    (permas-uci-mode . help-uci-command)
    (permas-unv-mode . unv-help-dataset)
    (TeX-mode        . help-tex-command)
    (tex-mode        . help-tex-command)
    (plain-tex-mode  . help-tex-command)
    (texinfo-mode    . help-tex-command)
    (latex-mode      . help-tex-command)
    (LaTeX-mode      . help-tex-command))
"Alist of mode-dependent default functions fo `context-help'")

;;;----------------------------------------------------------------------------
(setq context-help-function   'elisp-context-help)

(require 'thingatpt)
(setq test nil)
(defun elisp-context-help () "Context-help for actual lisp symbol at point."
  (interactive)
  (let ((key (symbol-at-point))
        (type      "FUNCTION/COMMAND")
        (keysymbol (variable-at-point)))
       (if keysymbol (setq type "VARIABLE")
                     (setq keysymbol (function-called-at-point)))
       (if keysymbol (progn
          (if (equal type "VARIABLE") (describe-variable keysymbol)
                                      (describe-function keysymbol))
          (message (concat "Description of lisp " type
                           " \"" (symbol-name keysymbol) "\"")))
          (message (concat "Lisp symbol '" (word-at-point)
                           "' unknown (invalid or local symbol) !")))
       (setq test key)))
