;;; This file is an addition to the GNU Emacs. GNU Emacs and the herein GOLD
;;; additions are distributed in the hope that it will be useful, but without
;;; ANY WARRANTY.  No author or distributor accepts responsibility to anyone
;;; for the consequences of using it or for whether it serves any particular
;;; purpose or works at all, unless he says so in writing.
;;; Everyone is granted permission to copy, modify and redistribute GNU Emacs,
;;; but only under the conditions described in the GNU Emacs General Public Li-
;;; cense.   A copy of this license is supposed to have been given to you along
;;; with GNU Emacs so you can know your rights and responsibilities.  It should
;;; be in a file named COPYING.  Among other things, the copyright notice and
;;; this notice must be preserved on all copies.
;;; Refer to the GNU Emacs General Public License for full details.
;;;
;;;############################################################################
;;;###  Additional functions for company/user-customization in gold.el !    ###
;;;###  This file is included (direct- or auto-loaded) by the main entry    ###
;;;###  file >>> gold.el <<< => Refer to that file for more informations.   ###
;;;############################################################################
;;; Bug reports and suggestions are always welcome !
;;;
(gold-debug "gold_company")
;;;-----------------------
;;
;; Variables for Company-Stuff:
;;==============================
(defvar company-name            nil "*Short name of company.")
(defvar company-address-name    nil "*Full name of company for addresses.")
(defvar company-address-street  nil "*Street name for addresses.")
(defvar company-address-postbox nil "*Postbox number as string.")
(defvar company-address-town    nil "*Full town name.")
(defvar company-town            nil "*Short name of company's town.")
(defvar company-state           nil "*Name of the company's state.")
(defvar company-phone           nil "*Phone number as string.")
(defvar company-fax             nil "*Fax number as string.")
(defvar company-email           nil "*E-Mail address as string.")
(defvar company-copyright       nil "*Name string used for Copyright notices.")
;;
;;****************************************************************************
;;***** Function to Look for additional company and/or user-definitions ! ****
;;****************************************************************************
(defvar user-init-file "~/.emacs_gold"
  "Name of user's init file loaded after GOLD-GNU-Emacs Installation !")
;;
(setq user-init-file "~/.emacs_gold") ; Overwrite startup's default "~/.emacs"
(if (not (file-readable-p user-init-file))
    (if (file-readable-p "~/.emacs_intes")
        (rename-file-with-message "~/.emacs_intes" user-init-file)
))
;;
(defun load-company/user-init-files () "Text missing..."
   (interactive)
   (message (concat "Hello " user-first-name " - Installing GOLD-GNU-Emacs"
            (if (file-readable-p user-init-file)
                (concat " and Your " user-init-file " Definitions !")
                ":  Please wait !")))
   ;;
   ;; Load companies definition (no error if not readable):
   (gold-debug "company-init-file")
   (load "company" t t)
   (setq gnus-local-organization company-name)
   ;;
   ;; Load user's init-file (if readable):
   (gold-debug user-init-file)
   (if (file-readable-p user-init-file)
       (if (not (load user-init-file nil t t))
           (progn (message (concat "Error reading " user-init-file))
                  (sleep-for 2))))
   ;;
   ;; Load user's keyboard-macro-file (if not identical to user-init-file):
   (gold-debug user-kbd-file)
   (or (string= user-kbd-file user-init-file)
       (if (file-readable-p user-kbd-file) (load user-kbd-file nil t t)))
   ;;
)

;;----------------------------------------------------------------------------
(provide 'gold_company)
