;;; This file is an addition to the GNU Emacs. GNU Emacs and the herein GOLD
;;; additions are distributed in the hope that it will be useful, but without
;;; ANY WARRANTY.  No author or distributor accepts responsibility to anyone
;;; for the consequences of using it or for whether it serves any particular
;;; purpose or works at all, unless he says so in writing.
;;; Everyone is granted permission to copy, modify and redistribute GNU Emacs,
;;; but only under the conditions described in the GNU Emacs General Public Li-
;;; cense.   A copy of this license is supposed to have been given to you along
;;; with GNU Emacs so you can know your rights and responsibilities.  It should
;;; be in a file named COPYING.  Among other things, the copyright notice and
;;; this notice must be preserved on all copies.
;;; Refer to the GNU Emacs General Public License for full details.
;;;
;;;############################################################################
;;;###  Compilation interface and utilities !                               ###
;;;###  This file is included (direct- or auto-loaded) by the main entry    ###
;;;###  file >>> gold.el <<< => Refer to that file for more informations.   ###
;;;############################################################################
;;; Bug reports and suggestions are always welcome !
;;;
;;;----------------------------------------------------------------------------
(gold-debug "gold_compile")
(require 'compile)
;;;----------------------------------------------------------------------------
(defvar compile-buffer-function nil
"Function called (if non-nil) to perform `compile-buffer'.
Each buffer has its own value of this variable.")
;;
(make-variable-buffer-local 'compile-buffer-function)
;;
(setq-default compile-buffer-function nil)
;;;----------------------------------------------------------------------------
(defun eval-buffer-or-region ()
"Execute the region or - if no region defined - the current buffer as Lisp code
(short-cut interface to `eval-region' respectively `eval-current-buffer')."
  (interactive)
  (let ((type "REGION") (start (region-beginning)) (end (region-end)))
       (if (or (not mark-active)
               (region-equal-buffer start end)) (setq type "BUFFER"))
       (message "Executing Lisp code in current %s !" type)
       (eval-region start end nil) (setq mark-active nil)))
;;
(defun recompile-dir ()
"Recompile every `.el' file in DIRECTORY that needs recompilation.
(short-cut interface to `byte-recompile-directory')."
  (interactive)
  (let ((save-case-fold-search case-fold-search))
       (save-excursion (call-interactively 'byte-recompile-directory))
       (setq case-fold-search save-case-fold-search)
))
;;;----------------------------------------------------------------------------
;; To be improved (copy from old hack):
;;
(defun compile-buffer () " " (interactive)
  (cond (compile-buffer-function (funcall compile-buffer-function))
        ((equal major-mode 'jde-mode) (jde-compile))
        (t (call-interactively 'compile))))
;;
;(defun my-compile-buffer (command)
;  (save-window-excursion ...
;  (compile-internal (concat command " " (buffer-name)) "No more errors")))
;;
(defun my-compile-buffer (command)
  (let ((file-name (file-relative-name (buffer-file-name)))
        (compilation-read-command nil)) (save-buffer)
       (compile (concat command " " file-name))))
;;
;;-----------------------------------------------------------------------------
(provide 'gold_compile)
