;;; This file is an addition to the GNU Emacs. GNU Emacs and the herein GOLD
;;; additions are distributed in the hope that it will be useful, but without
;;; ANY WARRANTY.  No author or distributor accepts responsibility to anyone
;;; for the consequences of using it or for whether it serves any particular
;;; purpose or works at all, unless he says so in writing.
;;; Everyone is granted permission to copy, modify and redistribute GNU Emacs,
;;; but only under the conditions described in the GNU Emacs General Public Li-
;;; cense.   A copy of this license is supposed to have been given to you along
;;; with GNU Emacs so you can know your rights and responsibilities.  It should
;;; be in a file named COPYING.  Among other things, the copyright notice and
;;; this notice must be preserved on all copies.
;;; Refer to the GNU Emacs General Public License for full details.
;;;
;;;############################################################################
;;;###  Additional GOLD Customizations of X-Terminal 'hilighting' features. ###
;;;###  This file is included (direct- or auto-loaded) by the main entry    ###
;;;###  file >>> gold.el <<< => Refer to that file for more informations.   ###
;;;############################################################################
;;; Bug reports and suggestions are always welcome !
;;
(gold-debug "gold_face")
(require 'font-lock)
(or xemacs (global-font-lock-mode t))
;(setq font-lock-maximum-decoration '((ps-mode . 1)))
;(setq font-lock-maximum-size '((ps-mode . 100)))
(setq font-lock-multiline t)
;;-----------------------------------------------------------------------
(setq jit-lock-stealth-load 50)
;(setq jit-lock-stealth-time nil);???
;;(if (featurep 'jit-lock) ;; NewDefault in Emacs-21
;;    (progn (setq jit-lock-stealth-load 50)
;;          ;(setq jit-lock-stealth-time nil);???
;;           )
;;    (progn (require 'lazy-lock) ;; Old AddOn for Emacs-19/20
;;           (setq font-lock-support-mode 'lazy-lock-mode)
;;           (setq lazy-lock-stealth-load 50)
;;))
;;-----------------------------------------------------------------------
;;
(defface font-lock-field-name-face
  '((((class color) (background light)) (:foreground "ForestGreen"))
    (((class color) (background dark)) (:foreground "PaleGreen"))
    (t (:inverse-video t :bold t)))
  "Font Lock mode face used to highlight field names."
  :group 'font-lock-highlighting-faces)
;;
(defface font-lock-reference-face
  '((((class grayscale) (background light)) (:foreground "LightGray" :bold t :underline t))
    (((class grayscale) (background dark )) (:foreground "Gray50" :bold t :underline t))
    (((class color    ) (background light)) (:foreground "Black" :background "Pink"))
    (((class color    ) (background dark )) (:foreground "Aquamarine"))
    (t (:bold t :underline t)))
  "Font Lock mode face used to highlight references."
  :group 'font-lock-highlighting-faces)
;;
(defface font-lock-separator-face
  '((((class grayscale) (background light)) (:foreground "LightGray" :bold t :underline t))
    (((class grayscale) (background dark )) (:foreground "Gray50" :bold t :underline t))
    (((class color    ) (background light)) (:foreground "Black" :background "Pink"))
    (((class color    ) (background dark )) (:foreground "Aquamarine"))
    (t (:bold t :underline t)))
  "Font Lock mode face used to highlight references."
  :group 'font-lock-highlighting-faces)
;;
(defface font-lock-list-face
  '((((class grayscale) (background light)) (:foreground "LightGray" :bold t :underline t))
    (((class grayscale) (background dark )) (:foreground "Gray50" :bold t :underline t))
    (((class color    ) (background light)) (:foreground "Black" :background "PapayaWhip"))
    (((class color    ) (background dark )) (:foreground "Aquamarine"))
    (t (:bold t :underline t)))
  "Font Lock mode face used to highlight references."
  :group 'font-lock-highlighting-faces)
;;
(defface font-lock-token-face
  '((((class grayscale) (background light)) (:foreground "LightGray" :bold t :underline t))
    (((class grayscale) (background dark )) (:foreground "Gray50" :bold t :underline t))
    (((class color    ) (background light)) (:foreground "Black" :background "khaki"))
    (((class color    ) (background dark )) (:foreground "Aquamarine"))
    (t (:bold t :underline t)))
  "Font Lock mode face used to highlight references."
  :group 'font-lock-highlighting-faces)
;;
(defface font-lock-gold-face
  '((((class grayscale) (background light)) (:foreground "LightGray" :bold t :underline t))
    (((class grayscale) (background dark )) (:foreground "Gray50" :bold t :underline t))
    (((class color    ) (background light)) (:foreground "Black" :background "gold"))
    (((class color    ) (background dark )) (:foreground "Aquamarine"))
    (t (:bold t :underline t)))
  "Font Lock mode face used to highlight references."
  :group 'font-lock-highlighting-faces)
;;
(defface font-lock-match-face
  '((((class color)) (:background "turquoise"))
    (t (:background "gray")))
  "Mode face used for `matching' items."
  :group 'font-lock-highlighting-faces)

(defface font-lock-mismatch-face
  '((((class color)) (:foreground "white" :background "purple"))
    (t (:reverse-video t)))
  "Mode face used for items that do NOT `match'."
  :group 'font-lock-highlighting-faces)


(defface font-lock-border-face
  '((((class grayscale) (background light)) (:foreground "DimGray" :slant italic))
    (((class grayscale) (background dark )) (:foreground "LightGray" :slant italic))
    (((class color    ) (background light)) (:foreground "VioletRed4" :background "SeaShell"))
    (((class color    ) (background dark )) (:foreground "LightSalmon"))
    (t (:slant italic)))
  "Font Lock mode face used to highlight tabular borders."
  :group 'font-lock-faces)
;
;  '((((class grayscale) (background light)) (:foreground "DimGray" :slant italic))
;    (((class grayscale) (background dark)) (:foreground "LightGray" :slant italic))
;    (((class color) (min-colors 88) (background light))
;     (:foreground "VioletRed4" :background "SeaShell"))
;    (((class color) (min-colors 88) (background dark)) (:foreground "LightSalmon"))
;    (((class color) (min-colors 16) (background light))
;     (:foreground "RosyBrown"))
;    (((class color) (min-colors 16) (background dark)) (:foreground "LightSalmon"))
;    (((class color) (min-colors 8)) (:foreground "green"))
;;
(defface font-lock-grey25-face
  '((t (:foreground "Gray75" :background "Gray75"))) "Grey25" :group 'font-lock-highlighting-faces)
;;
(defface font-lock-grey50-face
  '((t (:foreground "Gray60" :background "Gray60"))) "Grey50" :group 'font-lock-highlighting-faces)
;;
(defface font-lock-grey75-face
  '((t (:foreground "Gray40" :background "Gray40"))) "Grey75" :group 'font-lock-highlighting-faces)
;;
(set-face-foreground 'font-lock-reference-face "Black")
(set-face-background 'font-lock-reference-face "Pink")
;;(set-face-background 'font-lock-reference-face "LightGreen")
;;
;;----------------------------------------------------------------------------
;; Ignore GTK-Toolkit colors for some faces (24.4): Stolen from faces.el
(custom-set-faces 
  '(region ((((class color) (min-colors 88) (background dark))  :background "blue3")
            (((class color) (min-colors 88) (background light)) :background "lightgoldenrod2")
            (((class color) (min-colors 16) (background dark))  :background "blue3")
            (((class color) (min-colors 16) (background light)) :background "lightgoldenrod2")
            (((class color) (min-colors 8))  :background "blue" :foreground "white")
            (((type tty) (class mono)) :inverse-video t)
            (t :background "gray"))
            t "Basic face for highlighting the region without gtk from Emacs 24.2"))

;;----------------------------------------------------------------------------
(provide 'gold_face)
