;;; This file is an addition to the GNU Emacs. GNU Emacs and the herein GOLD
;;; additions are distributed in the hope that it will be useful, but without
;;; ANY WARRANTY.  No author or distributor accepts responsibility to anyone
;;; for the consequences of using it or for whether it serves any particular
;;; purpose or works at all, unless he says so in writing.
;;; Everyone is granted permission to copy, modify and redistribute GNU Emacs,
;;; but only under the conditions described in the GNU Emacs General Public Li-
;;; cense.   A copy of this license is supposed to have been given to you along
;;; with GNU Emacs so you can know your rights and responsibilities.  It should
;;; be in a file named COPYING.  Among other things, the copyright notice and
;;; this notice must be preserved on all copies.
;;; Refer to the GNU Emacs General Public License for full details.
;;;
;;;############################################################################
;;;###  Windows(95/98/NT) dependent Key/Mouse-Bindings and -Functions.      ###
;;;###  This file is included (direct- or auto-loaded) by the main entry    ###
;;;###  file >>> gold.el <<< => Refer to that file for more informations.   ###
;;;############################################################################
;;; Bug reports and suggestions are always welcome !
;;
(gold-debug "gold_windows")


;; Unmodified Keypad keys:
;;=========================
(define-key global-map [kp-add]      (key-binding [kp-subtract]))
(define-key global-map [kp-divide]   (key-binding [kp-f2]))
(define-key global-map [kp-multiply] (key-binding [kp-f3]))
(define-key global-map [kp-subtract] (key-binding [kp-f4]))
(define-key global-map [kp-decimal]  (key-binding [kp-period]))
;;
;; Scroll-Block
(define-key global-map [home]        'line-to-top-of-window)
(define-key global-map [end]         (key-binding [select]))
;;
;; Function-Keys
(define-key global-map [f1]          (key-binding [f6]))
(define-key global-map [f2]          (key-binding [f7]))
(define-key global-map [f3]          (key-binding [f8]))
(define-key global-map [f4]          (key-binding [f9]))
(define-key global-map [f5]          (key-binding [f11]))
(define-key global-map [f6]          (key-binding [f12]))
(define-key global-map [f7]          (key-binding [f13]))
(define-key global-map [f8]          (key-binding [f16]))
(define-key global-map [f9]          (key-binding [f17]))
(define-key global-map [f10]         (key-binding [f18]))
(define-key global-map [f11]         (key-binding [f19]))
(define-key global-map [f12]         (key-binding [f20]))


;; GOLD Keypad keys:
;;===================
(define-key GOLD-map   [kp-add]      (key-binding [gold kp-subtract]))
(define-key GOLD-map   [kp-divide]   (key-binding [gold kp-f2]))
(define-key GOLD-map   [kp-multiply] (key-binding [gold kp-f3]))
(define-key GOLD-map   [kp-subtract] (key-binding [gold kp-f4]))
(define-key GOLD-map   [key-decimal] (key-binding [gold kp-period]))
;;
;; GOLD-Scroll-Block
(define-key GOLD-map   [home]        (key-binding [gold deletechar]))
(define-key GOLD-map   [end]         (key-binding [gold select]))
;;
;; GOLD-Function-Keys
(define-key GOLD-map   [f1]          (key-binding [gold f6]))
(define-key GOLD-map   [f2]          (key-binding [gold f7]))
(define-key GOLD-map   [f3]          (key-binding [gold f8]))
(define-key GOLD-map   [f4]          (key-binding [gold f9]))
(define-key GOLD-map   [f5]          (key-binding [gold f11]))
(define-key GOLD-map   [f6]          (key-binding [gold f12]))
(define-key GOLD-map   [f7]          (key-binding [gold f14]))
(define-key GOLD-map   [f8]          (key-binding [gold f16]))
(define-key GOLD-map   [f9]          (key-binding [gold f17]))
(define-key GOLD-map   [f10]         (key-binding [gold f18]))
(define-key GOLD-map   [f11]         (key-binding [gold f19]))
(define-key GOLD-map   [f12]         (key-binding [gold f20]))

;; Get Keyboard language:
;;------------------------
(setq keyboard-language "DEU") ;; currently we do not know how to detect this

;;----------------------------------------------------------------------------
(provide 'gold_windows)
