;;; kmail.el --- KDE's kmail (editing kmail's mail bodies)

;; Copyright (C) 1999 Free Software Foundation, Inc.

;; Last Change: 27-Mar-01
;; Keywords: mail, kde, kmail

;; This file is part of GNU Emacs.

;; GNU Emacs is free software; you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; GNU Emacs is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with GNU Emacs; see the file COPYING.  If not, write to the
;; Free Software Foundation, Inc., 59 Temple Place - Suite 330,
;; Boston, MA 02111-1307, USA.

;;; Commentary:

;; kmail-edit-mode is a major mode for editing/viewing kmail's mail bodies.

;;; Code:

;;;###autoload
;;;;;;;;;;;;;;;;;;;;; currently kmail needs gold_mail !!!!????
(defun kmail-edit-mode ()
  "Editing mode for kmail's mail bodies."
  (interactive)
  (require 'sendmail) (build-mail-aliases) (build-mail-abbrevs)
  (mail-mode) ; start with standard mail-mode (highlighting, abbrevs,
              ; show-mail-aliases, comment-starter, etc.)
  (setq mode-name  "kmail-edit") (setq major-mode 'kmail-edit-mode)
  (local-set-key "\C-c\C-c"      'kmail-save-and-exit)
  (setq compile-buffer-function  'kmail-save-and-exit)
;   (raise-frame) ;???? pop-up minimized frames
  (new-frame) ;????? pop-up a new frame/window
  (set-buffer-modified-p t)
  (run-hooks 'kmail-edit-mode-hook))
;;
(defun kmail-save-and-exit () "Save kmail-buffer and leave emacs[client]."
   (interactive) ;; do nothing if not in kmail-edit-mode ?????
   (save-buffer) (server-edit)  ;; ??? if not emacsclient ???
   (delete-frame) (kill-buffer (current-buffer)))
;; ? delete-window & delete-frame ?
;;
(provide 'kmail)
