;;; This file is an addition to the GNU Emacs. GNU Emacs and the herein GOLD
;;; additions are distributed in the hope that it will be useful, but without
;;; ANY WARRANTY.  No author or distributor accepts responsibility to anyone
;;; for the consequences of using it or for whether it serves any particular
;;; purpose or works at all, unless he says so in writing.
;;; Everyone is granted permission to copy, modify and redistribute GNU Emacs,
;;; but only under the conditions described in the GNU Emacs General Public Li-
;;; cense.   A copy of this license is supposed to have been given to you along
;;; with GNU Emacs so you can know your rights and responsibilities.  It should
;;; be in a file named COPYING.  Among other things, the copyright notice and
;;; this notice must be preserved on all copies.
;;; Refer to the GNU Emacs General Public License for full details.
;;;
;;;############################################################################
;;;###  Special permas-aba-mode for ABAQUS *.inp input files !              ###
;;;###  This file is included (direct- or auto-loaded) by the main entry    ###
;;;###  file >>> gold.el <<< => Refer to that file for more informations.   ###
;;;############################################################################
;;; Bug reports and suggestions are always welcome !
;;
(gold-debug "permas_aba")
(defun permas-aba-mode ()
  "Editing mode for ABAQUS *.inp input files."
  (interactive)
  (kill-all-local-variables) (text-mode) ;;; ??? (setq overwrite-mode t)
  (use-local-map permas-aba-mode-map)
  (setq mode-name "PERMAS-ABA") (setq major-mode 'permas-aba-mode)
  (set (make-local-variable 'font-lock-defaults) '(permas-aba-font-lock-keywords t t))
  (if font-lock-mode (font-lock-mode 1)) ;no guess why we need this
  (run-mode-hooks 'permas-aba-mode-hook))
;
(defvar permas-aba-mode-map nil "Local keymap used in permas-aba-mode (ABAQUS-Files).")
(if     permas-aba-mode-map () (setq permas-aba-mode-map (make-sparse-keymap))
  (define-key permas-aba-mode-map ""    'permas-aba-next-block)
  (define-key permas-aba-mode-map ""    'permas-aba-prev-block)
)

;; font-lock support (list of regular expressions for highlighting)
;;-----------------------------------------------------------------
(setq permas-aba-font-lock-keywords
  (list
   '("^[*][a-z][ a-z0-9]*"      . 'font-lock-reference-face)
   ;; switch = value
   '("\\([a-z]+\\) *= *\\([a-z.0-9_+-]+\\)"
                                            (1 'font-lock-variable-name-face)
                                            (2 'font-lock-type-face))
))

;; Next/prev step
;;----------------
(defun permas-aba-prev-block () "Move to start of current dataset block"
  (interactive)
  (re-search-backward "^ *[*] *[a-z]" nil "t"
      (if (looking-at "^ *[*] *[a-z]" ) 2 1 ))
)
(defun permas-aba-next-block () "Move to start of next dataset block"
  (interactive)
  (if (re-search-forward "^ *[*] *[a-z]" nil "t"
         (if (looking-at "^ *[*] *[a-z]" ) 3 2 ))
      (beginning-of-line))
)
;;
;;----------------------------------------------------------------------------
(provide 'permas_aba)
