;;; permas_rsc.el --- PERMAS RSC mode (editing PERMAS Resource files)

;; Copyright (C) 1999-2015 Free Software Foundation, Inc.

;; Last Change: 31-Jul-15
;; Keywords: PERMAS, RSC, editing

;; This file is part of GNU Emacs.

;; GNU Emacs is free software; you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; GNU Emacs is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with GNU Emacs; see the file COPYING.  If not, write to the
;; Free Software Foundation, Inc., 59 Temple Place - Suite 330,
;; Boston, MA 02111-1307, USA.

;;; Commentary:

;; permas-rsc-mode is a major mode for editing PERMAS RSC files.

;;; Code:

;;;###autoload
(defun permas-rsc-mode ()
  "Text-mode for viewing/editing PERMAS RSC-Files."
  (interactive) (text-mode) (setq mode-name "PERMAS-RSC")
  (make-local-variable 'comment-start) (setq comment-start "#")
  (setq major-mode 'permas-rsc-mode)
  (set (make-local-variable 'font-lock-defaults) '(permas-rsc-font-lock-keywords t t))
  (if font-lock-mode (font-lock-mode 1)) ;no guess why we need this
  (run-mode-hooks 'permas-rsc-mode-hook))


;; font-lock support (list of regular expressions for highlighting)
;;-----------------------------------------------------------------
(setq permas-rsc-font-lock-keywords
  (list
   ;;
   ;; keyword = value
   '("=\\([^;:=!\n]*\\)"              (1 'font-lock-variable-name-face t))
   '("\\([a-z][^ ]*\\) *="            (1 'font-lock-type-face t)) ; t=Overwrite
   ;;
   ;; Standard comments
   '("#.*"                            (0 'font-lock-comment-face t))
))

(provide 'permas_rsc)

;;; permas_rsc.el ends here
